import{s as at,f as V,n as mt,o as ht}from"../chunks/scheduler.63274e7e.js";import{S as pt,i as ct,g as r,s as n,r as U,A as ut,h as o,f as i,c as l,j as ot,u as J,x as a,k as m,y as gt,a as s,v as N,d as R,t as D,w as Y}from"../chunks/index.bf3f3f8e.js";import{H as X,E as ft}from"../chunks/EditOnGithub.7d836abf.js";function yt(ze){let h,Z,K,ee,c,te,u,Ee="Before diving into making the demo, we must <strong>understand sentence similarity and how it works</strong>.",ie,g,se,f,Ge="In this game, we want to <strong>give more freedom to the player</strong>: instead of giving an order to a robot by just clicking a button, we want them to interact with it through text.",ne,y,We="The robot has a list of actions and <strong>uses a sentence similarity model that selects the closest action</strong> (if any) given the player’s order.",le,d,qe,re,v,Ae="For instance, if I write, “Hey, grab me the red box”, <strong>the robot isn’t programmed to know what “Hey, grab me the red box” is</strong>. But the sentence similarity model connected this order with the “bring red box” action we programmed for the robot.",oe,w,Oe="Therefore, thanks to this technique, <strong>we can build believable character AI without having the tedious process of mapping every possible player input interaction to robot response by hand</strong>. We let the sentence similarity model do the job for us!",ae,b,me,T,Be="Sentence Similarity is a task that, given a source sentence and a set of target sentences, <strong>calculates how similar the target sentences are to the source</strong>.",he,H,Fe='<img src="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentence-similarity-example.jpg" alt="Sentence Similarity Example"/> <figcaption>Source: https://huggingface.co/tasks/sentence-similarity</figcaption>',pe,$,Ue="For instance, if our source sentence (player order) is “Hey grab me the red box”, it’s very close to the “Bring red box” sentence in the action list.",ce,x,Je,ue,M,Ne="Sentence similarity models convert input text, like “Hello”, into vectors (called embeddings) that capture semantic information. We call this step to embed. Then, we calculate how close (similar) they are using <strong>cosine similarity</strong>.",ge,_,Re="I’ll not go into the details, but the essence is: since our sentence similarity models produce vectors, we can calculate <strong>the cosine of the angle between two vectors. The closer the result is to 1, the more similar these two vectors are.</strong>",fe,L,De='<img src="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/cosine.png" alt="Cosine similarity"/> <figcaption>Source: https://zhangruochi.com/Operations-on-word-vectors-Debiasing/2019/03/28/</figcaption>',ye,k,Ye='If you want to dive deeper into the sentence similarity task, check this 👉 <a href="https://huggingface.co/tasks/sentence-similarity" rel="nofollow">https://huggingface.co/tasks/sentence-similarity</a>',de,C,ve,S,Ke="Now that we understand Sentence Similarity, <strong>let’s see the entire pipeline: from the moment a player inputs an order to the robot acting</strong>.",we,P,Qe,be,I,Ve='<li><p>The player types an order: “Can you bring me the red cube?”</p></li> <li><p>The robot has a list of actions [“Hello”, “Happy”, “Bring red box”, “Move to blue pillar”]</p></li> <li><p>What we want to do then is to embed this player input text <strong>to compare to the robot action list to find the most similar action (if any).</strong></p></li> <li><p>To do that <strong>we tokenize the input</strong>: a Transformer model can’t take a string as input. <strong>It needs to be translated into numbers.</strong> This is done using the Tokenizer code provided by <a href="https://github.com/huggingface/sharp-transformers" rel="nofollow">Sharp Transformers</a>.</p></li> <li><p>Then, the input (tokenized) is passed to the model <strong>that outputs an embedding of this text</strong>: a vector that captures semantic information about the text. This inference part is done by Unity Sentis.</p></li>',Te,j,Xe,He,p,Ze="<li><p>Now we can compare <strong>this vector with other vectors (from the action list) using cosine similarity.</strong></p></li> <li><p>We select the action with the <strong>highest similarity and get the similarity score.</strong></p></li>",$e,z,et="If the similarity score &gt; 0.2, <strong>we ask the robot to perform the action.</strong>",xe,E,tt="Otherwise, we ask the robot to perform the “I’m perplexed” animation. Since the order given <strong>is too different from the action list</strong> (it can be the case if the player for instance writes something totally irrelevant like “do you like rabbits?“.",Me,G,it,_e,W,Le,q,st="This is a threshold value: if the similarity score is below it, <strong>we consider the player’s order too different from the possible robot action list</strong>.",ke,A,nt="It was found by <strong>testing</strong> different threshold scores.",Ce,O,lt="More importantly, this <strong>not a fixed threshold</strong> since the similarity score of all the possible robot actions sums to 1. You must decrease this threshold <strong>if you add more action to the robot action list</strong>.",Se,B,rt="Now that we understand the whole pipeline, you might wonder <strong>how to run this AI model.</strong> In the player’s machine or remotely? And what are the differences. That’s the topic of the next section.",Pe,F,Ie,Q,je;return c=new X({props:{title:"The power of Sentence Similarity 🤖",local:"the-power-of-sentence-similarity-",headingTag:"h1"}}),g=new X({props:{title:"How does this game work?",local:"how-does-this-game-work",headingTag:"h2"}}),b=new X({props:{title:"What is Sentence Similarity?",local:"what-is-sentence-similarity",headingTag:"h2"}}),C=new X({props:{title:"The Complete pipeline",local:"the-complete-pipeline",headingTag:"h2"}}),W=new X({props:{title:"Why 0.2 for the similarity score threshold?",local:"why-02-for-the-similarity-score-threshold",headingTag:"h3"}}),F=new ft({props:{source:"https://github.com/huggingface/making-games-with-ai-course/blob/main/units/en/unit1/sentence-similarity-explained.mdx"}}),{c(){h=r("meta"),Z=n(),K=r("p"),ee=n(),U(c.$$.fragment),te=n(),u=r("p"),u.innerHTML=Ee,ie=n(),U(g.$$.fragment),se=n(),f=r("p"),f.innerHTML=Ge,ne=n(),y=r("p"),y.innerHTML=We,le=n(),d=r("img"),re=n(),v=r("p"),v.innerHTML=Ae,oe=n(),w=r("p"),w.innerHTML=Oe,ae=n(),U(b.$$.fragment),me=n(),T=r("p"),T.innerHTML=Be,he=n(),H=r("figure"),H.innerHTML=Fe,pe=n(),$=r("p"),$.textContent=Ue,ce=n(),x=r("img"),ue=n(),M=r("p"),M.innerHTML=Ne,ge=n(),_=r("p"),_.innerHTML=Re,fe=n(),L=r("figure"),L.innerHTML=De,ye=n(),k=r("p"),k.innerHTML=Ye,de=n(),U(C.$$.fragment),ve=n(),S=r("p"),S.innerHTML=Ke,we=n(),P=r("img"),be=n(),I=r("ol"),I.innerHTML=Ve,Te=n(),j=r("img"),He=n(),p=r("ol"),p.innerHTML=Ze,$e=n(),z=r("p"),z.innerHTML=et,xe=n(),E=r("p"),E.innerHTML=tt,Me=n(),G=r("img"),_e=n(),U(W.$$.fragment),Le=n(),q=r("p"),q.innerHTML=st,ke=n(),A=r("p"),A.innerHTML=nt,Ce=n(),O=r("p"),O.innerHTML=lt,Se=n(),B=r("p"),B.innerHTML=rt,Pe=n(),U(F.$$.fragment),Ie=n(),Q=r("p"),this.h()},l(e){const t=ut("svelte-u9bgzb",document.head);h=o(t,"META",{name:!0,content:!0}),t.forEach(i),Z=l(e),K=o(e,"P",{}),ot(K).forEach(i),ee=l(e),J(c.$$.fragment,e),te=l(e),u=o(e,"P",{"data-svelte-h":!0}),a(u)!=="svelte-1bf7i67"&&(u.innerHTML=Ee),ie=l(e),J(g.$$.fragment,e),se=l(e),f=o(e,"P",{"data-svelte-h":!0}),a(f)!=="svelte-h698ms"&&(f.innerHTML=Ge),ne=l(e),y=o(e,"P",{"data-svelte-h":!0}),a(y)!=="svelte-173h1xj"&&(y.innerHTML=We),le=l(e),d=o(e,"IMG",{src:!0,alt:!0}),re=l(e),v=o(e,"P",{"data-svelte-h":!0}),a(v)!=="svelte-83zu2i"&&(v.innerHTML=Ae),oe=l(e),w=o(e,"P",{"data-svelte-h":!0}),a(w)!=="svelte-rtq7ef"&&(w.innerHTML=Oe),ae=l(e),J(b.$$.fragment,e),me=l(e),T=o(e,"P",{"data-svelte-h":!0}),a(T)!=="svelte-y1cfeb"&&(T.innerHTML=Be),he=l(e),H=o(e,"FIGURE",{"data-svelte-h":!0}),a(H)!=="svelte-y1k99x"&&(H.innerHTML=Fe),pe=l(e),$=o(e,"P",{"data-svelte-h":!0}),a($)!=="svelte-s50bh2"&&($.textContent=Ue),ce=l(e),x=o(e,"IMG",{src:!0,alt:!0}),ue=l(e),M=o(e,"P",{"data-svelte-h":!0}),a(M)!=="svelte-1tqty1d"&&(M.innerHTML=Ne),ge=l(e),_=o(e,"P",{"data-svelte-h":!0}),a(_)!=="svelte-1idef2z"&&(_.innerHTML=Re),fe=l(e),L=o(e,"FIGURE",{"data-svelte-h":!0}),a(L)!=="svelte-191b6y7"&&(L.innerHTML=De),ye=l(e),k=o(e,"P",{"data-svelte-h":!0}),a(k)!=="svelte-1qcux57"&&(k.innerHTML=Ye),de=l(e),J(C.$$.fragment,e),ve=l(e),S=o(e,"P",{"data-svelte-h":!0}),a(S)!=="svelte-11fe8fx"&&(S.innerHTML=Ke),we=l(e),P=o(e,"IMG",{src:!0,alt:!0}),be=l(e),I=o(e,"OL",{"data-svelte-h":!0}),a(I)!=="svelte-kn4i6b"&&(I.innerHTML=Ve),Te=l(e),j=o(e,"IMG",{src:!0,alt:!0}),He=l(e),p=o(e,"OL",{start:!0,"data-svelte-h":!0}),a(p)!=="svelte-7mm36f"&&(p.innerHTML=Ze),$e=l(e),z=o(e,"P",{"data-svelte-h":!0}),a(z)!=="svelte-1bf25kn"&&(z.innerHTML=et),xe=l(e),E=o(e,"P",{"data-svelte-h":!0}),a(E)!=="svelte-1uziz64"&&(E.innerHTML=tt),Me=l(e),G=o(e,"IMG",{src:!0,alt:!0}),_e=l(e),J(W.$$.fragment,e),Le=l(e),q=o(e,"P",{"data-svelte-h":!0}),a(q)!=="svelte-5eyccj"&&(q.innerHTML=st),ke=l(e),A=o(e,"P",{"data-svelte-h":!0}),a(A)!=="svelte-38vuwv"&&(A.innerHTML=nt),Ce=l(e),O=o(e,"P",{"data-svelte-h":!0}),a(O)!=="svelte-1o25cnz"&&(O.innerHTML=lt),Se=l(e),B=o(e,"P",{"data-svelte-h":!0}),a(B)!=="svelte-1hvs3y0"&&(B.innerHTML=rt),Pe=l(e),J(F.$$.fragment,e),Ie=l(e),Q=o(e,"P",{}),ot(Q).forEach(i),this.h()},h(){m(h,"name","hf:doc:metadata"),m(h,"content",dt),V(d.src,qe="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentence-similarity.jpg")||m(d,"src",qe),m(d,"alt","Sentence Similarity Pipeline"),V(x.src,Je="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentence-similarity.jpg")||m(x,"src",Je),m(x,"alt","Sentence Similarity Pipeline"),V(P.src,Qe="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/jammo-process.jpg")||m(P,"src",Qe),m(P,"alt","Jammo Process"),V(j.src,Xe="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/jammo-process-1.jpg")||m(j,"src",Xe),m(j,"alt","Jammo process part 1"),m(p,"start","6"),V(G.src,it="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/rabbits.gif")||m(G,"src",it),m(G,"alt","Jammo rabbits")},m(e,t){gt(document.head,h),s(e,Z,t),s(e,K,t),s(e,ee,t),N(c,e,t),s(e,te,t),s(e,u,t),s(e,ie,t),N(g,e,t),s(e,se,t),s(e,f,t),s(e,ne,t),s(e,y,t),s(e,le,t),s(e,d,t),s(e,re,t),s(e,v,t),s(e,oe,t),s(e,w,t),s(e,ae,t),N(b,e,t),s(e,me,t),s(e,T,t),s(e,he,t),s(e,H,t),s(e,pe,t),s(e,$,t),s(e,ce,t),s(e,x,t),s(e,ue,t),s(e,M,t),s(e,ge,t),s(e,_,t),s(e,fe,t),s(e,L,t),s(e,ye,t),s(e,k,t),s(e,de,t),N(C,e,t),s(e,ve,t),s(e,S,t),s(e,we,t),s(e,P,t),s(e,be,t),s(e,I,t),s(e,Te,t),s(e,j,t),s(e,He,t),s(e,p,t),s(e,$e,t),s(e,z,t),s(e,xe,t),s(e,E,t),s(e,Me,t),s(e,G,t),s(e,_e,t),N(W,e,t),s(e,Le,t),s(e,q,t),s(e,ke,t),s(e,A,t),s(e,Ce,t),s(e,O,t),s(e,Se,t),s(e,B,t),s(e,Pe,t),N(F,e,t),s(e,Ie,t),s(e,Q,t),je=!0},p:mt,i(e){je||(R(c.$$.fragment,e),R(g.$$.fragment,e),R(b.$$.fragment,e),R(C.$$.fragment,e),R(W.$$.fragment,e),R(F.$$.fragment,e),je=!0)},o(e){D(c.$$.fragment,e),D(g.$$.fragment,e),D(b.$$.fragment,e),D(C.$$.fragment,e),D(W.$$.fragment,e),D(F.$$.fragment,e),je=!1},d(e){e&&(i(Z),i(K),i(ee),i(te),i(u),i(ie),i(se),i(f),i(ne),i(y),i(le),i(d),i(re),i(v),i(oe),i(w),i(ae),i(me),i(T),i(he),i(H),i(pe),i($),i(ce),i(x),i(ue),i(M),i(ge),i(_),i(fe),i(L),i(ye),i(k),i(de),i(ve),i(S),i(we),i(P),i(be),i(I),i(Te),i(j),i(He),i(p),i($e),i(z),i(xe),i(E),i(Me),i(G),i(_e),i(Le),i(q),i(ke),i(A),i(Ce),i(O),i(Se),i(B),i(Pe),i(Ie),i(Q)),i(h),Y(c,e),Y(g,e),Y(b,e),Y(C,e),Y(W,e),Y(F,e)}}}const dt='{"title":"The power of Sentence Similarity 🤖","local":"the-power-of-sentence-similarity-","sections":[{"title":"How does this game work?","local":"how-does-this-game-work","sections":[],"depth":2},{"title":"What is Sentence Similarity?","local":"what-is-sentence-similarity","sections":[],"depth":2},{"title":"The Complete pipeline","local":"the-complete-pipeline","sections":[{"title":"Why 0.2 for the similarity score threshold?","local":"why-02-for-the-similarity-score-threshold","sections":[],"depth":3}],"depth":2}],"depth":1}';function vt(ze){return ht(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ht extends pt{constructor(h){super(),ct(this,h,vt,yt,at,{})}}export{Ht as component};
